//@ sourceURL=menu_manage.js
$(function () {
    $("#btn_add").click(function (t) {
        $("#editModal").modal();
        $("#classTitle").text("新增");
        clearInput();
    });

    $(".selectpicker").selectpicker({
        dropuAuto: false
    });
    initAllParentMenu();
    $("#btn_save").click(function (t) {
        saveMenu();
    });
    getAllMenu();
});


/**
 * 挂号列表中的科室列表
 */
function initAllParentMenu() {
    //科室列表
    $.ajax({
        type: "GET",
        url: '/thmz/getAllParentMenu',
        dataType: "json",
        headers: {'Accept': 'application/json', 'Authorization': 'Bearer ' + localStorage.getItem("token")},
        success: function (data) {
            if (data == '401' || data == 401) {
                window.location.href = '/thmz/login/view'
                return;
            }
            var html = '<option value="-1"></option>';
            $.each(data.data, function (commentIndex, comment) {
                html += '<option value="' + comment.id + '">' + comment.name + '</option>';
            });
            $('#parentId').empty();
            $('#parentId').html(html);
            $('#parentId').selectpicker('refresh');
        }
    });
}


/**
 * 保存号表数据
 */
function saveMenu() {
    var id=$("#id").val();
    var data = null;
    //修改菜单
    if(id!=null){
        data = JSON.stringify({
            id: id,
            name: $("#name").val(),
            parentId: $("#parentId").val(),
            classCode: $("#classCode").val(),
            menuUrl: $("#menuUrl").val(),
            sortValue: $("#sortValue").val()
        });
    }else {
        //新增菜单
        data = JSON.stringify({
            name: $("#name").val(),
            parentId: $("#parentId").val(),
            classCode: $("#classCode").val(),
            menuUrl: $("#menuUrl").val(),
            sortValue: $("#sortValue").val()
        });
    }
    $.ajax({
        type: "POST",
        url: '/thmz/saveMenu',
        contentType: "application/json;charset=UTF-8",
        dataType: "json",
        headers: {'Accept': 'application/json', 'Authorization': 'Bearer ' + localStorage.getItem("token")},
        data: data,
        success: function (res) {
            if (res == '401' || res == 401) {
                window.location.href = '/thmz/login/view'
                return;
            }
            if (res.code == 0) {
                $("#editModal").modal("hide");
                clearInput();
                initAllParentMenu();
                $('#tb_table').bootstrapTable('refresh');
                successMesage(res);
            } else {
                errorMesage(res);
            }
        }
    });
}


/**
 * 清空输入框
 */
function clearInput() {
    $("#id").val(null);
    $("#name").val(null);
    $('#parentId').selectpicker('val', null);
    $('#parentId').selectpicker('refresh')
    $("#classCode").val(null);
    $("#menuUrl").val(null);
    $("#sortValue").val(null);
}


/**
 * 查询菜单列表
 */
function getAllMenu() {
    $('#tb_table').bootstrapTable("destroy");
    $('#tb_table').bootstrapTable({
        url: '/thmz/getAllMenu',         //请求后台的URL（*）
        method: 'post',                      //请求方式（*）
        toolbar: '#toolbar',                //工具按钮用哪个容器
        striped: true,                      //是否显示行间隔色
        cache: false,                       //是否使用缓存，默认为true，所以一般情况下需要设置一下这个属性（*）
        pagination: true,                   //是否显示分页（*）
        sortable: true,                     //是否启用排序
        sortOrder: "asc",                   //排序方式
        queryParams: queryParams,           //传递参数（*）
        sidePagination: "client",           //分页方式：client客户端分页，server服务端分页（*）
        pageNumber: 1,                       //初始化加载第一页，默认第一页
        pageSize: 10,                       //每页的记录行数（*）
        pageList: [10, 25, 50, 100],        //可供选择的每页的行数（*）
        search: false,                       //是否显示表格搜索，此搜索是客户端搜索，不会进服务端，所以，个人感觉意义不大
        strictSearch: true,
        showColumns: false,                  //是否显示所有的列
        showRefresh: false,                  //是否显示刷新按钮
        minimumCountColumns: 2,             //最少允许的列数
        clickToSelect: true,                //是否启用点击选中行
        uniqueId: "ID",                     //每一行的唯一标识，一般为主键列
        showToggle: false,                    //是否显示详细视图和列表视图的切换按钮
        cardView: false,                    //是否显示详细视图
        detailView: false,
        //rowStyle:rowStyle,//通过自定义函数设置行样式
        ajaxOptions: {
            headers: {
                'Accept': 'application/json',
                'Authorization': 'Bearer ' + localStorage.getItem("token")
            }
        },
        columns: [
            {
                title: '操作',
                align: "center",
                valign: 'middle',
                formatter: function (value, row, index) {
                    var str = '<button type="button" class="btn btn-primary  btn-sm" onclick="editMenu(' + row.id + ')">编辑</button>';
                    str += '<button type="button" class="btn btn-warning  btn-sm" onclick="deleteMenu(' + row.id + ')">删除</button>';
                    return [str].join('');
                }
            },
            {
                field: 'name',
                title: '菜单名称',
                align: "center",
                valign: 'middle'
            }, {
                field: 'patentName',
                title: '父菜单',
                align: "center",
                valign: 'middle',
            }, {
                field: 'classCode',
                title: '图标样式',
                align: "center",
                valign: 'middle',
            }, {
                field: 'classCode',
                title: '图标',
                align: "center",
                valign: 'middle',
                formatter: function (value, row, index) {
                    var str = '<span class="' + value + '"></span>';
                    return [str].join('');
                }

            }, {
                field: 'menuUrl',
                title: '菜单地址',
                align: "center",
                valign: 'middle'
            }, {
                field: 'sortValue',
                title: '排序',
                align: "center",
                valign: 'middle'
            }
        ],
        responseHandler: function (res) {
            if (res == '401' || res == 401) {
                window.location.href = '/thmz/login/view'
                return;
            }
            var ress = eval(res);
            if (ress.code == -1) {
                if (ress.message != null && ress.message != '') {
                    new PNotify({
                        title: '错误提示',
                        text: ress.message,
                        type: 'error',
                        hide: true,
                        styling: 'bootstrap3'
                    });
                }
                return {
                    "total": 0,//总页数
                    "rows": {}   //数据
                };
            }
            return {
                "total": ress.data.length,//总页数
                "rows": ress.data   //数据
            };
        },
    });
}

/**
 * 构建列表查询参数
 * @param params
 * @returns {{mzChargeDetail: {patientId: string | number | string[] | undefined | jQuery, warnDept: string | number | string[] | undefined | jQuery, doctorCode: string | number | string[] | undefined | jQuery, name: string | number | string[] | undefined | jQuery, payMark: number}, beginTime: Date, endTime: Date, pageSize: *, pageIndex: number}}
 */
function queryParams(params) {
    var temp = {
        name: $('#nameParam').val()
    };
    return temp;
};


/**
 * 打开编辑窗口
 * @param id
 */
function editMenu(id) {
    $("#classTitle").text("修改");
    $.ajax({
        type: "GET",
        url: '/thmz/getMenu?id='+id,
        dataType: "json",
        headers: {'Accept': 'application/json', 'Authorization': 'Bearer ' + localStorage.getItem("token")},
        success: function (res) {
            if (res == '401' || res == 401) {
                window.location.href = '/thmz/login/view'
                return;
            }
            if(res.code==0){
                $("#id").val(res.data.id);
                $("#name").val(res.data.name);
                $('#parentId').selectpicker('val', res.data.parentId);
                $('#parentId').selectpicker('refresh');
                $("#classCode").val(res.data.classCode);
                $("#menuUrl").val(res.data.menuUrl);
                $("#sortValue").val(res.data.sortValue);
                $("#editModal").modal();
            }else {
                errorMesage(res);
            }
        }
    });
}

/**
 * 删除菜单
 * @param id
 */
function deleteMenu(id) {
    if (!confirm("是否要删除当前菜单？")) {
        return;
    }
    $.ajax({
        type: "GET",
        url: '/thmz/deleteMenu?id=' + id,
        dataType: "json",
        headers: {'Accept': 'application/json', 'Authorization': 'Bearer ' + localStorage.getItem("token")},
        success: function (res) {
            if (res == '401' || res == 401) {
                window.location.href = '/thmz/login/view'
                return;
            }
            if (res.code == 0) {
                $('#tb_table').bootstrapTable('refresh');
                successMesage(res);
            } else {
                errorMesage(res);
            }
        }
    });
}


